
#property indicator_chart_window

extern bool ChartAlerts = FALSE;
extern bool EmailAlerts = FALSE;
extern string EmailSubject = "MT4 chart setup: ";
extern int LookbackBars = 500000;
extern double VerticalSpacing = 1.5;
extern int ShowMinLevelArrows = 1;
extern int ShowMaxLevelArrows = 5;
extern int StartHour = 0;
extern int EndHour = 23;
extern double MinBarHeight = 5.0;
extern double MaxBarHeight = 999.0;
extern bool ShowBullishSetups = TRUE;
extern bool ShowBearishSetups = TRUE;
extern bool ShowFollowSameColor = TRUE;
extern bool ShowFollowOppColor = TRUE;
extern bool OUTSIDEBARS = false;
extern color OutsideBarColor = White;
extern double OBCloseWithinXpct = 40.0;
extern double OBMinBodyPct = 0.0;
extern double OBMaxBodyPct = 100.0;
extern bool ENGULFBODIES = false;
extern color EngulfBodyColor = Yellow;
extern double EBCloseWithinXpct = 40.0;
extern double EBMinBodyPct = 0.0;
extern double EBMaxBodyPct = 100.0;
extern int EBSizeRatioPct = 100;
extern double EBTolerance = 2.0;
extern bool EBMustBreak = FALSE;
extern bool PINBARS = TRUE;
extern color PinBarColor = LightYellow;
extern double PBCloseWithinXpct = 50.0;
extern double PBMinOuterWickPct = 50.0;
extern int PBClearBars = 5;
extern int PBClearPips = 10;
extern bool PBCheckColor = FALSE;
extern bool HANGINGMEN = false;
extern color HangManColor = LightYellow;
extern double HMCloseWithinXpct = 50.0;
extern double HMMinInnerWickPct = 50.0;
extern int HMMinTrendBars = 5;
extern double HMTolerance = 2.0;
extern bool RAILTRACKS = false;
extern color RailTrackColor = BlueViolet;
extern double RTMinBodyPct = 60.0;
extern double RTMaxBodyDiffPct = 20.0;
extern double RTTolerance = 2.0;
extern bool KONGBARS = false;
extern color KongBarColor = ForestGreen;
extern double KBCloseWithinXpct = 40.0;
extern double KBMinBodyPct = 0.0;
extern double KBMaxBodyPct = 100.0;
extern int KBSizeRatioPct = 125;
extern int KBLookbackBars = 25;
extern bool KBUseAveHeights = TRUE;
extern bool KBCompareBody = TRUE;
extern bool DOJIS = false;
extern color DojiColor = DarkGoldenrod;
extern double DojiMaxBodyPct = 5.0;
extern double DojiCentralPct = 100.0;
extern bool INSIDEBARS = TRUE;
extern color InsideBarColor = CornflowerBlue;
extern bool DBLTOPSBOTS = false;
extern color DoubleTBColor = Gray;
extern double DoubleTBTolerance = 2.0;
extern int DoubleTBLookback = 5;
extern int DoubleTBBarsGap = 0;
extern bool DoubleTBWiderClose = FALSE;
string gsymbol444;
int gdigits452;
int giunused456;
int gtimeframe460;
double gd464;
datetime gtime472;

int init() {
   CheckPresets();
   gsymbol444 = Symbol();
   gtimeframe460 = Period();
   gd464 = MarketInfo(gsymbol444, MODE_POINT);
   gdigits452 = MarketInfo(gsymbol444, MODE_DIGITS);
   giunused456 = MarketInfo(gsymbol444, MODE_SPREAD);
   if (gdigits452 == 3 || gdigits452 == 5) gd464 = 10.0 * gd464;
   delobj();
   plotobj(0);
   gtime472 = -9999;
   return (0);
}

int deinit() {
   delobj();
   return (0);
}

int start() {
   if (gtime472 != Time[0]) {
      delobj();
      plotobj(1);
   }
   gtime472 = Time[0];
   return (0);
}

void delobj() {
   string lname4;
   int li0 = 0;
   while (li0 < ObjectsTotal()) {
      lname4 = ObjectName(li0);
      if (StringSubstr(lname4, 0, 4) == "obid") ObjectDelete(lname4);
      else li0++;
   }
}

void plotobj(int ai0) {
   int lcount4;
   int lhour12;
   double ld16;
   double ld24;
   double ld32;
   double ld40;
   double ld48;
   double ld56;
   bool li64;
   bool li68;
   bool li72;
   double ld76;
   double ld84;
   double ld92;
   bool li104;
   bool li108;
   double ld112;
   double ld120;
   double ld128;
   bool li136;
   bool li140;
   bool li144;
   bool li148;
   bool li152;
   bool li156;
   bool li160;
   double ld164;
   double ld172;
   double ld180;
   bool li188;
   bool li192;
   int li196;
   string ls200;
   string ls212;
   double lprice220;
   double lprice228;
   int lwidth236;
   int lwidth240;
   for (int li8 = 1; li8 <= MathMin(Bars - 1, LookbackBars); li8++) {
      lhour12 = TimeHour(Time[li8]);
      if (lhour12 < StartHour || lhour12 > EndHour) continue;
      if (High[li8] - Low[li8] < MinBarHeight * gd464 || High[li8] - Low[li8] > MaxBarHeight * gd464) continue;
      if (!ShowFollowSameColor && (Close[li8] - Open[li8]) * (Close[li8 + 1] - (Open[li8 + 1])) > 0.0) continue;
      if (!ShowFollowOppColor && (Close[li8] - Open[li8]) * (Close[li8 + 1] - (Open[li8 + 1])) < 0.0) continue;
      ld16 = DivZero(MathAbs(Close[li8] - Open[li8]), High[li8] - Low[li8]);
      ld24 = 100.0 * DivZero(Close[li8] - Low[li8], High[li8] - Low[li8]);
      ld32 = MathMax(Open[li8], Close[li8]);
      ld40 = MathMin(Open[li8], Close[li8]);
      ld48 = MathMax(Open[li8 + 1], Close[li8 + 1]);
      ld56 = MathMin(Open[li8 + 1], Close[li8 + 1]);
      li64 = TRUE;
      if (!OUTSIDEBARS || High[li8] < High[li8 + 1] || Low[li8] > Low[li8 + 1]) li64 = FALSE;
      if (ld16 < OBMinBodyPct / 100.0) li64 = FALSE;
      if (ld16 > OBMaxBodyPct / 100.0) li64 = FALSE;
      if (Close[li8] > Open[li8] && 100 - OBCloseWithinXpct > ld24) li64 = FALSE;
      if (Close[li8] < Open[li8] && ld24 > OBCloseWithinXpct) li64 = FALSE;
      li68 = TRUE;
      if (EBTolerance < 0.0 || !ENGULFBODIES) li68 = FALSE;
      else {
         if (ld32 - ld40 < (ld48 - ld56) * EBSizeRatioPct / 100.0) li68 = FALSE;
         if (ld32 < ld48 - EBTolerance * gd464 || ld40 > ld56 + EBTolerance * gd464) li68 = FALSE;
         if (Close[li8] > Open[li8] && High[li8] < High[li8 + 1] && EBMustBreak) li68 = FALSE;
         if (Close[li8] < Open[li8] && Low[li8] > Low[li8 + 1] && EBMustBreak) li68 = FALSE;
         if (ld16 < EBMinBodyPct / 100.0) li68 = FALSE;
         if (ld16 > EBMaxBodyPct / 100.0) li68 = FALSE;
         if (Close[li8] > Open[li8] && 100 - EBCloseWithinXpct > ld24) li68 = FALSE;
         if (Close[li8] < Open[li8] && ld24 > EBCloseWithinXpct) li68 = FALSE;
      }
      li72 = TRUE;
      if (!KONGBARS) li72 = FALSE;
      else {
         if (ld16 < KBMinBodyPct / 100.0) li72 = FALSE;
         if (ld16 > KBMaxBodyPct / 100.0) li72 = FALSE;
         if (Close[li8] > Open[li8] && 100 - KBCloseWithinXpct > ld24) li72 = FALSE;
         if (Close[li8] < Open[li8] && ld24 > KBCloseWithinXpct) li72 = FALSE;
         ld76 = High[li8] - Low[li8];
         if (KBCompareBody) ld76 = MathAbs(Close[li8] - Open[li8]);
         ld84 = 0;
         ld92 = 0;
         for (int li100 = 1; li100 <= KBLookbackBars; li100++) {
            if (KBCompareBody) {
               ld84 = MathMax(ld84, MathAbs(Close[li8 + li100] - (Open[li8 + li100])));
               ld92 += MathAbs(Close[li8 + li100] - (Open[li8 + li100])) / KBLookbackBars;
            } else {
               ld84 = MathMax(ld84, High[li8 + li100] - (Low[li8 + li100]));
               ld92 += (High[li8 + li100] - (Low[li8 + li100])) / KBLookbackBars;
            }
         }
         if (!KBUseAveHeights) ld92 = ld84;
         if (ld76 < ld92 * KBSizeRatioPct / 100.0) li72 = FALSE;
      }
      li104 = TRUE;
      if (!INSIDEBARS || High[li8] > High[li8 + 1] || Low[li8] < Low[li8 + 1]) li104 = FALSE;
      li108 = TRUE;
      if (!DOJIS) li108 = FALSE;
      if (ld16 > DojiMaxBodyPct / 100.0) li108 = FALSE;
      ld112 = (High[li8] + Low[li8]) / 2.0;
      ld120 = (Open[li8] + Close[li8]) / 2.0;
      ld128 = (High[li8] - Low[li8]) * DojiCentralPct / 200.0;
      if (ld120 > ld112 + ld128 || ld120 < ld112 - ld128) li108 = FALSE;
      li136 = TRUE;
      if (!PINBARS) li136 = FALSE;
      if (100 - PBCloseWithinXpct < ld24) li140 = TRUE;
      else li140 = FALSE;
      if (ld24 < PBCloseWithinXpct) li144 = TRUE;
      else li144 = FALSE;
      if (!li140 && !li144) li136 = FALSE;
      if (li140) {
         if (PBCheckColor && Close[li8] < Open[li8]) li136 = FALSE;
         for (li100 = 1; li100 <= PBClearBars; li100++)
            if (Low[li8] > Low[li8 + li100] - PBClearPips * gd464) li136 = FALSE;
         if (MathMin(Open[li8], Close[li8]) - Low[li8] < (High[li8] - Low[li8]) * PBMinOuterWickPct / 100.0) li136 = FALSE;
      }
      if (li144) {
         if (PBCheckColor && Close[li8] > Open[li8]) li136 = FALSE;
         for (li100 = 1; li100 <= PBClearBars; li100++)
            if (High[li8] < High[li8 + li100] + PBClearPips * gd464) li136 = FALSE;
         if (High[li8] - MathMax(Open[li8], Close[li8]) < (High[li8] - Low[li8]) * PBMinOuterWickPct / 100.0) li136 = FALSE;
      }
      li148 = TRUE;
      if (!HANGINGMEN) li148 = FALSE;
      if (100 - HMCloseWithinXpct < ld24) li152 = TRUE;
      else li152 = FALSE;
      if (ld24 < HMCloseWithinXpct) li156 = TRUE;
      else li156 = FALSE;
      if (!li156 && !li152) li148 = FALSE;
      if (li156) {
         for (li100 = 1; li100 <= HMMinTrendBars; li100++)
            if (Low[li8] > Low[li8 + li100] + HMTolerance * gd464) li148 = FALSE;
         if (High[li8] - MathMax(Open[li8], Close[li8]) < (High[li8] - Low[li8]) * HMMinInnerWickPct / 100.0) li148 = FALSE;
      }
      if (li152) {
         for (li100 = 1; li100 <= HMMinTrendBars; li100++)
            if (High[li8] < High[li8 + li100] - HMTolerance * gd464) li148 = FALSE;
         if (MathMin(Open[li8], Close[li8]) - Low[li8] < (High[li8] - Low[li8]) * HMMinInnerWickPct / 100.0) li148 = FALSE;
      }
      li160 = TRUE;
      if (!RAILTRACKS) li160 = FALSE;
      if (ld16 < RTMinBodyPct / 100.0) li160 = FALSE;
      if (ld16 < RTMinBodyPct / 100.0) li160 = FALSE;
      if ((Close[li8] - Open[li8]) * (Close[li8 + 1] - (Open[li8 + 1])) > 0.0) li160 = FALSE;
      ld164 = MathAbs(Close[li8 + 1] - (Open[li8 + 1]));
      ld172 = MathAbs(Close[li8] - Open[li8]);
      ld180 = MathAbs(ld172 - ld164);
      if (ld180 > ld164 * RTMaxBodyDiffPct / 100.0) li160 = FALSE;
      if (MathAbs(Close[li8 + 1] - Open[li8]) > RTTolerance * gd464) li160 = FALSE;
      if (li64) {
         li68 = FALSE;
         li136 = FALSE;
         li148 = FALSE;
         li160 = FALSE;
         li72 = FALSE;
         li108 = FALSE;
         li104 = FALSE;
      }
      if (li68) {
         li136 = FALSE;
         li148 = FALSE;
         li160 = FALSE;
         li72 = FALSE;
         li108 = FALSE;
         li104 = FALSE;
      }
      if (li136) {
         li148 = FALSE;
         li160 = FALSE;
         li72 = FALSE;
         li108 = FALSE;
         li104 = FALSE;
      }
      if (li148) {
         li160 = FALSE;
         li72 = FALSE;
         li108 = FALSE;
         li104 = FALSE;
      }
      if (li160) {
         li72 = FALSE;
         li108 = FALSE;
         li104 = FALSE;
      }
      if (li72) {
         li108 = FALSE;
         li104 = FALSE;
      }
      if (li108) li104 = FALSE;
      li188 = FALSE;
      li192 = FALSE;
      if (DBLTOPSBOTS) {
         for (li100 = 1; li100 <= DoubleTBLookback; li100++) {
            if (High[li8 + li100] > High[li8] + DoubleTBTolerance * gd464) break;
            if (MathAbs(High[li8 + li100] - High[li8]) <= DoubleTBTolerance * gd464 && li100 > DoubleTBBarsGap)
               if (!DoubleTBWiderClose || Close[li8] < Low[li8 + li100]) li188 = TRUE;
         }
         for (li100 = 1; li100 <= DoubleTBLookback; li100++) {
            if (Low[li8 + li100] < Low[li8] - DoubleTBTolerance * gd464) break;
            if (MathAbs(Low[li8 + li100] - Low[li8]) <= DoubleTBTolerance * gd464 && li100 > DoubleTBBarsGap)
               if (!DoubleTBWiderClose || Close[li8] > High[li8 + li100]) li192 = TRUE;
         }
      }
      if (!li64 && !li68 && !li104 && !li136 && !li148 && !li160 && !li108 && !li72 && !li188 && !li192) continue;
      li196 = 0;
      if (Close[li8] > Open[li8]) li196 = 1;
      if (Close[li8] <= Open[li8]) li196 = -1;
      if (li136) {
         if (li140) li196 = 1;
         if (li144) li196 = -1;
      }
      if (li148) {
         if (li156) li196 = 1;
         if (li152) li196 = -1;
      }
      ls200 = gsymbol444 + ",";
      switch (gtimeframe460) {
      case PERIOD_M1:
         ls200 = ls200 + "M1 : ";
         break;
      case PERIOD_M5:
         ls200 = ls200 + "M5 : ";
         break;
      case PERIOD_M15:
         ls200 = ls200 + "M15 : ";
         break;
      case PERIOD_M30:
         ls200 = ls200 + "M30 : ";
         break;
      case PERIOD_H1:
         ls200 = ls200 + "H1 : ";
         break;
      case PERIOD_H4:
         ls200 = ls200 + "H4 : ";
         break;
      case PERIOD_D1:
         ls200 = ls200 + "D1 : ";
         break;
      case PERIOD_W1:
         ls200 = ls200 + "W1 : ";
         break;
      case PERIOD_MN1:
         ls200 = ls200 + "MN : ";
         break;
      default:
         ls200 = ls200 + "?? : ";
      }
      ls212 = " ";
      lprice220 = iHigh(gsymbol444, gtimeframe460, li8) + 10.0 * gd464 + 10.0 * VerticalSpacing * gd464;
      lprice228 = iLow(gsymbol444, gtimeframe460, li8) - 5.0 * VerticalSpacing * gd464;
      lwidth236 = 0;
      lwidth240 = 0;
      if (li64 || li68 || li104 || li136 || li148 || li160 || li108 || li72) {
         if (li196 == 1 && ShowBullishSetups) {
            lcount4 = 0;
            if (High[li8 + 2] > High[li8 + 1]) lcount4 += 2;
            if (High[li8 + 3] > High[li8 + 2]) lcount4++;
            if (High[li8 + 4] >= High[li8 + 3]) lcount4++;
            if (High[li8 + 5] >= High[li8 + 4]) lcount4++;
            if (High[li8 + 10] > High[li8 + 1]) lcount4++;
            if (High[li8 + 15] > High[li8 + 1]) lcount4++;
            lwidth236 = MathMin(MathMax(1, lcount4 - 1), 5);
            if (lwidth236 >= ShowMinLevelArrows && lwidth236 <= ShowMaxLevelArrows) {
               ObjectCreate("obid" + li8, OBJ_ARROW, 0, iTime(gsymbol444, gtimeframe460, li8), lprice228);
               ObjectSet("obid" + li8, OBJPROP_ARROWCODE, SYMBOL_ARROWUP);
               ObjectSet("obid" + li8, OBJPROP_WIDTH, lwidth236);
            }
         }
         if (li196 == -1 && ShowBearishSetups) {
            lcount4 = 0;
            if (Low[li8 + 2] < Low[li8 + 1]) lcount4 += 2;
            if (Low[li8 + 3] < Low[li8 + 2]) lcount4++;
            if (Low[li8 + 4] <= Low[li8 + 3]) lcount4++;
            if (Low[li8 + 5] <= Low[li8 + 4]) lcount4++;
            if (Low[li8 + 10] < Low[li8 + 1]) lcount4++;
            if (Low[li8 + 15] < Low[li8 + 1]) lcount4++;
            lwidth240 = MathMin(MathMax(1, lcount4 - 1), 5);
            if (lwidth240 >= ShowMinLevelArrows && lwidth240 <= ShowMaxLevelArrows) {
               ObjectCreate("obid" + li8, OBJ_ARROW, 0, iTime(gsymbol444, gtimeframe460, li8), lprice220);
               ObjectSet("obid" + li8, OBJPROP_ARROWCODE, SYMBOL_ARROWDOWN);
               ObjectSet("obid" + li8, OBJPROP_WIDTH, lwidth240);
            }
         }
         if (li64) {
            ObjectSet("obid" + li8, OBJPROP_COLOR, OutsideBarColor);
            ls212 = "Outside Bar";
         }
         if (li68) {
            ObjectSet("obid" + li8, OBJPROP_COLOR, EngulfBodyColor);
            ls212 = "Engulfing Body";
         }
         if (li136) {
            ObjectSet("obid" + li8, OBJPROP_COLOR, PinBarColor);
            ls212 = "Pinbar";
         }
         if (li148) {
            ObjectSet("obid" + li8, OBJPROP_COLOR, HangManColor);
            ls212 = "Hanging Man";
         }
         if (li160) {
            ObjectSet("obid" + li8, OBJPROP_COLOR, RailTrackColor);
            ls212 = "Railroad Track";
         }
         if (li72) {
            ObjectSet("obid" + li8, OBJPROP_COLOR, KongBarColor);
            ls212 = "Kong Bar";
         }
         if (li108) {
            ObjectSet("obid" + li8, OBJPROP_COLOR, DojiColor);
            ls212 = "Doji";
         }
         if (li104) {
            ObjectSet("obid" + li8, OBJPROP_COLOR, InsideBarColor);
            ls212 = "Inside Bar";
         }
      }
      if (li188 && ShowBearishSetups) {
         ObjectCreate("obidt" + li8, OBJ_ARROW, 0, iTime(gsymbol444, gtimeframe460, li8), lprice220 + 3.0 * VerticalSpacing * lwidth240 * gd464);
         ObjectSet("obidt" + li8, OBJPROP_ARROWCODE, 159);
         ObjectSet("obidt" + li8, OBJPROP_COLOR, DoubleTBColor);
         ObjectSet("obidt" + li8, OBJPROP_WIDTH, 3);
         if (ls212 == " ") ls212 = "Double Top";
      }
      if (li192 && ShowBullishSetups) {
         ObjectCreate("obidb" + li8, OBJ_ARROW, 0, iTime(gsymbol444, gtimeframe460, li8), lprice228 - 3.0 * VerticalSpacing * lwidth236 * gd464);
         ObjectSet("obidb" + li8, OBJPROP_ARROWCODE, 159);
         ObjectSet("obidb" + li8, OBJPROP_COLOR, DoubleTBColor);
         ObjectSet("obidb" + li8, OBJPROP_WIDTH, 3);
         if (ls212 == " ") ls212 = "Double Bottom";
      }
      if (ls212 != " " && li8 == 1 && ai0) {
         ls200 = ls200 + ls212;
         if (ChartAlerts) Alert(ls200);
         if (EmailAlerts) SendMail(EmailSubject, ls200);
      }
   }
}

double DivZero(double ad0, double ad8) {
   if (ad8 == 0.0) return (0);
   return (ad0 / ad8);
}

int CheckPresets() {
   string ls16;
   int li24;
   string ls28;
   int li36;
   string ls44;
   int li52;
   string ls56;
   int li64;
   int li68;
   int li72;
   int li76;
   string ls80;
   string ls88;
   int li0 = 0;
   string lname4 = "Presets---Candle Identifier.TXT";
   int lfile12 = FileOpen(lname4, FILE_CSV|FILE_READ, ';');
   if (lfile12 > 0) {
      while (!FileIsEnding(lfile12)) {
         ls16 = FileReadString(lfile12);
         li24 = StringFind(ls16, "//", 0);
         if (li24 == 0) ls16 = "";
         else
            if (li24 > 0) ls16 = StringSubstr(ls16, 0, li24);
         ls28 = "";
         li36 = 0;
         for (int li40 = 0; li40 < StringLen(ls16); li40++) {
            ls44 = StringSubstr(ls16, li40, 1);
            if (ls44 == "\"") li36 = 1 - li36;
            else {
               if (li36 == 1) ls28 = ls28 + ls44;
               else
                  if (ls44 != " " && ls44 != "") ls28 = ls28 + StringLower(ls44);
            }
         }
         if (StringLen(ls28) > 0) {
            li52 = 0;
            if (StringFind(ls28, "m1:", 0) >= 0) li52 = 1;
            else {
               if (StringFind(ls28, "m5:", 0) >= 0) li52 = 5;
               else {
                  if (StringFind(ls28, "m15:", 0) >= 0) li52 = 15;
                  else {
                     if (StringFind(ls28, "m30:", 0) >= 0) li52 = 30;
                     else {
                        if (StringFind(ls28, "h1:", 0) >= 0) li52 = 60;
                        else {
                           if (StringFind(ls28, "h4:", 0) >= 0) li52 = 240;
                           else {
                              if (StringFind(ls28, "d1:", 0) >= 0) li52 = 1440;
                              else {
                                 if (StringFind(ls28, "w1:", 0) >= 0) li52 = 10080;
                                 else
                                    if (StringFind(ls28, "mn:", 0) >= 0) li52 = 43200;
                              }
                           }
                        }
                     }
                  }
               }
            }
            ls56 = "";
            li64 = StringFind(ls28, ",", 0);
            li68 = StringFind(ls28, ":", 0);
            li72 = StringFind(ls28, "=", 0);
            li76 = StringFind(ls28, ";", 0);
            if (li64 >= 0) ls56 = StringSubstr(ls28, 0, li64);
            else
               if (li68 >= 0) ls56 = StringSubstr(ls28, 0, li68);
            if (li64 < 0 && li52 > 0) ls56 = "";
            ls80 = "";
            if (li68 >= 0) ls80 = StringSubstr(ls28, li68 + 1, li72 - li68 - 1);
            else ls80 = StringSubstr(ls28, 0, li72);
            ls88 = StringSubstr(ls28, li72 + 1, li76 - li72 + 1);
            if (ls56 == "" || StringFind(StringLower(Symbol()), ls56, 0) >= 0 && li52 == 0 || li52 == Period() && ls88 != "*") {
               if (ls80 == "usepresets") li0 = StrToBool(ls88);
               else {
                  if (ls80 == "chartalerts") ChartAlerts = StrToBool(ls88);
                  else {
                     if (ls80 == "emailalerts") EmailAlerts = StrToBool(ls88);
                     else {
                        if (ls80 == "emailsubject") EmailSubject = ls88;
                        else {
                           if (ls80 == "lookbackbars") LookbackBars = StrToInteger(ls88);
                           else {
                              if (ls80 == "verticalspacing") VerticalSpacing = StrToDouble(ls88);
                              else {
                                 if (ls80 == "showminlevelarrows") ShowMinLevelArrows = StrToInteger(ls88);
                                 else {
                                    if (ls80 == "showmaxlevelarrows") ShowMaxLevelArrows = StrToInteger(ls88);
                                    else {
                                       if (ls80 == "starthour") StartHour = StrToInteger(ls88);
                                       else {
                                          if (ls80 == "endhour") EndHour = StrToInteger(ls88);
                                          else {
                                             if (ls80 == "minbarheight") MinBarHeight = StrToDouble(ls88);
                                             else {
                                                if (ls80 == "maxbarheight") MaxBarHeight = StrToDouble(ls88);
                                                else {
                                                   if (ls80 == "showbullishsetups") ShowBullishSetups = StrToBool(ls88);
                                                   else {
                                                      if (ls80 == "showbearishsetups") ShowBearishSetups = StrToBool(ls88);
                                                      else {
                                                         if (ls80 == "showfollowsamecolor") ShowFollowSameColor = StrToBool(ls88);
                                                         else {
                                                            if (ls80 == "showfollowoppcolor") ShowFollowOppColor = StrToBool(ls88);
                                                            else {
                                                               if (ls80 == "outsidebars") OUTSIDEBARS = StrToBool(ls88);
                                                               else {
                                                                  if (ls80 == "outsidebarcolor") OutsideBarColor = StrToColor(ls88);
                                                                  else {
                                                                     if (ls80 == "obclosewithinxpct") OBCloseWithinXpct = StrToDouble(ls88);
                                                                     else {
                                                                        if (ls80 == "obminbodypct") OBMinBodyPct = StrToDouble(ls88);
                                                                        else {
                                                                           if (ls80 == "obmaxbodypct") OBMaxBodyPct = StrToDouble(ls88);
                                                                           else {
                                                                              if (ls80 == "engulfbodies") ENGULFBODIES = StrToBool(ls88);
                                                                              else {
                                                                                 if (ls80 == "engulfbodycolor") EngulfBodyColor = StrToColor(ls88);
                                                                                 else {
                                                                                    if (ls80 == "ebclosewithinxpct") EBCloseWithinXpct = StrToDouble(ls88);
                                                                                    else {
                                                                                       if (ls80 == "ebminbodypct") EBMinBodyPct = StrToDouble(ls88);
                                                                                       else {
                                                                                          if (ls80 == "ebmaxbodypct") EBMaxBodyPct = StrToDouble(ls88);
                                                                                          else {
                                                                                             if (ls80 == "ebsizeratiopct") EBSizeRatioPct = StrToInteger(ls88);
                                                                                             else {
                                                                                                if (ls80 == "ebtolerance") EBTolerance = StrToDouble(ls88);
                                                                                                else {
                                                                                                   if (ls80 == "ebmustbreak") EBMustBreak = StrToBool(ls88);
                                                                                                   else {
                                                                                                      if (ls80 == "pinbars") PINBARS = StrToBool(ls88);
                                                                                                      else {
                                                                                                         if (ls80 == "pinbarcolor") PinBarColor = StrToColor(ls88);
                                                                                                         else {
                                                                                                            if (ls80 == "pbclosewithinxpct") PBCloseWithinXpct = StrToDouble(ls88);
                                                                                                            else {
                                                                                                               if (ls80 == "pbminouterwickpct") PBMinOuterWickPct = StrToDouble(ls88);
                                                                                                               else {
                                                                                                                  if (ls80 == "pbclearbars") PBClearBars = StrToInteger(ls88);
                                                                                                                  else {
                                                                                                                     if (ls80 == "pbclearpips") PBClearPips = StrToInteger(ls88);
                                                                                                                     else {
                                                                                                                        if (ls80 == "pbcheckcolor") PBCheckColor = StrToBool(ls88);
                                                                                                                        else {
                                                                                                                           if (ls80 == "hangingmen") HANGINGMEN = StrToBool(ls88);
                                                                                                                           else {
                                                                                                                              if (ls80 == "hangmancolor") HangManColor = StrToColor(ls88);
                                                                                                                              else {
                                                                                                                                 if (ls80 == "hmclosewithinxpct") HMCloseWithinXpct = StrToDouble(ls88);
                                                                                                                                 else {
                                                                                                                                    if (ls80 == "hmmininnerwickpct") HMMinInnerWickPct = StrToDouble(ls88);
                                                                                                                                    else {
                                                                                                                                       if (ls80 == "hmmintrendbars") HMMinTrendBars = StrToInteger(ls88);
                                                                                                                                       else {
                                                                                                                                          if (ls80 == "hmtolerance") HMTolerance = StrToDouble(ls88);
                                                                                                                                          else {
                                                                                                                                             if (ls80 == "railtracks") RAILTRACKS = StrToBool(ls88);
                                                                                                                                             else {
                                                                                                                                                if (ls80 == "railtrackcolor") RailTrackColor = StrToColor(ls88);
                                                                                                                                                else {
                                                                                                                                                   if (ls80 == "rtminbodypct") RTMinBodyPct = StrToDouble(ls88);
                                                                                                                                                   else {
                                                                                                                                                      if (ls80 == "rtmaxbodydiffpct") RTMaxBodyDiffPct = StrToDouble(ls88);
                                                                                                                                                      else {
                                                                                                                                                         if (ls80 == "rttolerance") RTTolerance = StrToDouble(ls88);
                                                                                                                                                         else {
                                                                                                                                                            if (ls80 == "kongbars") KONGBARS = StrToBool(ls88);
                                                                                                                                                            else {
                                                                                                                                                               if (ls80 == "kongbarcolor") KongBarColor = StrToColor(ls88);
                                                                                                                                                               else {
                                                                                                                                                                  if (ls80 == "kbclosewithinxpct") KBCloseWithinXpct = StrToDouble(ls88);
                                                                                                                                                                  else {
                                                                                                                                                                     if (ls80 == "kbminbodypct") KBMinBodyPct = StrToDouble(ls88);
                                                                                                                                                                     else {
                                                                                                                                                                        if (ls80 == "kbmaxbodypct") KBMaxBodyPct = StrToDouble(ls88);
                                                                                                                                                                        else {
                                                                                                                                                                           if (ls80 == "kbsizeratiopct") KBSizeRatioPct = StrToInteger(ls88);
                                                                                                                                                                           else {
                                                                                                                                                                              if (ls80 == "kblookbackbars") KBLookbackBars = StrToInteger(ls88);
                                                                                                                                                                              else {
                                                                                                                                                                                 if (ls80 == "kbuseaveheights") KBUseAveHeights = StrToBool(ls88);
                                                                                                                                                                                 else {
                                                                                                                                                                                    if (ls80 == "kbomparebody") KBCompareBody = StrToBool(ls88);
                                                                                                                                                                                    else {
                                                                                                                                                                                       if (ls80 == "dojis") DOJIS = StrToBool(ls88);
                                                                                                                                                                                       else {
                                                                                                                                                                                          if (ls80 == "dojicolor") DojiColor = StrToColor(ls88);
                                                                                                                                                                                          else {
                                                                                                                                                                                             if (ls80 == "dojimaxbodypct") DojiMaxBodyPct = StrToDouble(ls88);
                                                                                                                                                                                             else {
                                                                                                                                                                                                if (ls80 == "dojicentralpct") DojiCentralPct = StrToDouble(ls88);
                                                                                                                                                                                                else {
                                                                                                                                                                                                   if (ls80 == "insidebars") INSIDEBARS = StrToBool(ls88);
                                                                                                                                                                                                   else {
                                                                                                                                                                                                      if (ls80 == "insidebarcolor") InsideBarColor = StrToColor(ls88);
                                                                                                                                                                                                      else {
                                                                                                                                                                                                         if (ls80 == "dbltopsbots") DBLTOPSBOTS = StrToBool(ls88);
                                                                                                                                                                                                         else {
                                                                                                                                                                                                            if (ls80 == "doubletbcolor") DoubleTBColor = StrToColor(ls88);
                                                                                                                                                                                                            else {
                                                                                                                                                                                                               if (ls80 == "doubletbtolerance") DoubleTBTolerance = StrToDouble(ls88);
                                                                                                                                                                                                               else {
                                                                                                                                                                                                                  if (ls80 == "doubletblookback") DoubleTBLookback = StrToInteger(ls88);
                                                                                                                                                                                                                  else {
                                                                                                                                                                                                                     if (ls80 == "doubletbbarsgap") DoubleTBBarsGap = StrToInteger(ls88);
                                                                                                                                                                                                                     else
                                                                                                                                                                                                                        if (ls80 == "doubletbwiderclose") DoubleTBWiderClose = StrToBool(ls88);
                                                                                                                                                                                                                  }
                                                                                                                                                                                                               }
                                                                                                                                                                                                            }
                                                                                                                                                                                                         }
                                                                                                                                                                                                      }
                                                                                                                                                                                                   }
                                                                                                                                                                                                }
                                                                                                                                                                                             }
                                                                                                                                                                                          }
                                                                                                                                                                                       }
                                                                                                                                                                                    }
                                                                                                                                                                                 }
                                                                                                                                                                              }
                                                                                                                                                                           }
                                                                                                                                                                        }
                                                                                                                                                                     }
                                                                                                                                                                  }
                                                                                                                                                               }
                                                                                                                                                            }
                                                                                                                                                         }
                                                                                                                                                      }
                                                                                                                                                   }
                                                                                                                                                }
                                                                                                                                             }
                                                                                                                                          }
                                                                                                                                       }
                                                                                                                                    }
                                                                                                                                 }
                                                                                                                              }
                                                                                                                           }
                                                                                                                        }
                                                                                                                     }
                                                                                                                  }
                                                                                                               }
                                                                                                            }
                                                                                                         }
                                                                                                      }
                                                                                                   }
                                                                                                }
                                                                                             }
                                                                                          }
                                                                                       }
                                                                                    }
                                                                                 }
                                                                              }
                                                                           }
                                                                        }
                                                                     }
                                                                  }
                                                               }
                                                            }
                                                         }
                                                      }
                                                   }
                                                }
                                             }
                                          }
                                       }
                                    }
                                 }
                              }
                           }
                        }
                     }
                  }
               }
            }
            if (!(li0)) break;
         }
         ls28 = FileReadString(lfile12);
      }
      FileClose(lfile12);
   }
   return (0);
}

int StrToColor(string as0) {
   int lstr2int16;
   int lstr2int20;
   int lstr2int24;
   as0 = StringLower(as0);
   if (as0 == "aliceblue") return (16775408);
   if (as0 == "antiquewhite") return (14150650);
   if (as0 == "aqua") return (16776960);
   if (as0 == "aquamarine") return (13959039);
   if (as0 == "beige") return (14480885);
   if (as0 == "bisque") return (12903679);
   if (as0 == "black") return (0);
   if (as0 == "blanchedalmond") return (13495295);
   if (as0 == "blue") return (16711680);
   if (as0 == "blueviolet") return (14822282);
   if (as0 == "brown") return (2763429);
   if (as0 == "burlywood") return (8894686);
   if (as0 == "cadetblue") return (10526303);
   if (as0 == "chartreuse") return (65407);
   if (as0 == "chocolate") return (1993170);
   if (as0 == "coral") return (5275647);
   if (as0 == "cornflowerblue") return (15570276);
   if (as0 == "cornsilk") return (14481663);
   if (as0 == "crimson") return (3937500);
   if (as0 == "darkblue") return (9109504);
   if (as0 == "darkgoldenrod") return (755384);
   if (as0 == "darkgray") return (11119017);
   if (as0 == "darkgreen") return (25600);
   if (as0 == "darkkhaki") return (7059389);
   if (as0 == "darkolivegreen") return (3107669);
   if (as0 == "darkorange") return (36095);
   if (as0 == "darkorchid") return (13382297);
   if (as0 == "darksalmon") return (8034025);
   if (as0 == "darkseagreen") return (9157775);
   if (as0 == "darkslateblue") return (9125192);
   if (as0 == "darkslategray") return (5197615);
   if (as0 == "darkturquoise") return (13749760);
   if (as0 == "darkviolet") return (13828244);
   if (as0 == "deeppink") return (9639167);
   if (as0 == "deepskyblue") return (16760576);
   if (as0 == "dimgray") return (6908265);
   if (as0 == "dodgerblue") return (16748574);
   if (as0 == "firebrick") return (2237106);
   if (as0 == "forestgreen") return (2263842);
   if (as0 == "gainsboro") return (14474460);
   if (as0 == "gold") return (55295);
   if (as0 == "goldenrod") return (2139610);
   if (as0 == "gray") return (8421504);
   if (as0 == "green") return (32768);
   if (as0 == "greenyellow") return (3145645);
   if (as0 == "honeydew") return (15794160);
   if (as0 == "hotpink") return (11823615);
   if (as0 == "indianred") return (6053069);
   if (as0 == "indigo") return (8519755);
   if (as0 == "ivory") return (15794175);
   if (as0 == "khaki") return (9234160);
   if (as0 == "lavender") return (16443110);
   if (as0 == "lavenderblush") return (16118015);
   if (as0 == "lawngreen") return (64636);
   if (as0 == "lemonchiffon") return (13499135);
   if (as0 == "lightblue") return (15128749);
   if (as0 == "lightcoral") return (8421616);
   if (as0 == "lightcyan") return (16777184);
   if (as0 == "lightgoldenrod") return (13826810);
   if (as0 == "lightgray") return (13882323);
   if (as0 == "lightgreen") return (9498256);
   if (as0 == "lightpink") return (12695295);
   if (as0 == "lightsalmon") return (8036607);
   if (as0 == "lightseagreen") return (11186720);
   if (as0 == "lightskyblue") return (16436871);
   if (as0 == "lightslategray") return (10061943);
   if (as0 == "lightsteelblue") return (14599344);
   if (as0 == "lightyellow") return (14745599);
   if (as0 == "lime") return (65280);
   if (as0 == "limegreen") return (3329330);
   if (as0 == "linen") return (15134970);
   if (as0 == "magenta") return (16711935);
   if (as0 == "maroon") return (128);
   if (as0 == "mediumaquamarine") return (11193702);
   if (as0 == "mediumblue") return (13434880);
   if (as0 == "mediumorchid") return (13850042);
   if (as0 == "mediumpurple") return (14381203);
   if (as0 == "mediumseagreen") return (7451452);
   if (as0 == "mediumslateblue") return (15624315);
   if (as0 == "mediumspringgreen") return (10156544);
   if (as0 == "mediumturquoise") return (13422920);
   if (as0 == "mediumvioletred") return (8721863);
   if (as0 == "midnightblue") return (7346457);
   if (as0 == "mintcream") return (16449525);
   if (as0 == "mistyrose") return (14804223);
   if (as0 == "moccasin") return (11920639);
   if (as0 == "navajowhite") return (11394815);
   if (as0 == "navy") return (8388608);
   if (as0 == "none") return (0);
   if (as0 == "oldlace") return (15136253);
   if (as0 == "olive") return (32896);
   if (as0 == "olivedrab") return (2330219);
   if (as0 == "orange") return (42495);
   if (as0 == "orangered") return (17919);
   if (as0 == "orchid") return (14053594);
   if (as0 == "palegoldenrod") return (11200750);
   if (as0 == "palegreen") return (10025880);
   if (as0 == "paleturquoise") return (15658671);
   if (as0 == "palevioletred") return (9662683);
   if (as0 == "papayawhip") return (14020607);
   if (as0 == "peachpuff") return (12180223);
   if (as0 == "peru") return (4163021);
   if (as0 == "pink") return (13353215);
   if (as0 == "plum") return (14524637);
   if (as0 == "powderblue") return (15130800);
   if (as0 == "purple") return (8388736);
   if (as0 == "red") return (255);
   if (as0 == "rosybrown") return (9408444);
   if (as0 == "royalblue") return (14772545);
   if (as0 == "saddlebrown") return (1262987);
   if (as0 == "salmon") return (7504122);
   if (as0 == "sandybrown") return (6333684);
   if (as0 == "seagreen") return (5737262);
   if (as0 == "seashell") return (15660543);
   if (as0 == "sienna") return (2970272);
   if (as0 == "silver") return (12632256);
   if (as0 == "skyblue") return (15453831);
   if (as0 == "slateblue") return (13458026);
   if (as0 == "slategray") return (9470064);
   if (as0 == "snow") return (16448255);
   if (as0 == "springgreen") return (8388352);
   if (as0 == "steelblue") return (11829830);
   if (as0 == "tan") return (9221330);
   if (as0 == "teal") return (8421376);
   if (as0 == "thistle") return (14204888);
   if (as0 == "tomato") return (4678655);
   if (as0 == "turquoise") return (13688896);
   if (as0 == "violet") return (15631086);
   if (as0 == "wheat") return (11788021);
   if (as0 == "white") return (16777215);
   if (as0 == "whitesmoke") return (16119285);
   if (as0 == "yellow") return (65535);
   if (as0 == "yellowgreen") return (3329434);
   int li8 = StringFind(as0, ",", 0);
   int li12 = StringFind(as0, ",", li8 + 1);
   if (li8 > 0 && li12 > 0) {
      lstr2int16 = StrToInteger(StringSubstr(as0, 0, li8));
      lstr2int20 = StrToInteger(StringSubstr(as0, li8 + 1, li12 - 1));
      lstr2int24 = StrToInteger(StringSubstr(as0, li12 + 1, StringLen(as0)));
      return (lstr2int24 << 8 << 8 + lstr2int20 << 8 + lstr2int16);
   }
   return (0);
}

int StrToBool(string as0) {
   as0 = StringLower(StringSubstr(as0, 0, 1));
   if (as0 == "t" || as0 == "y" || as0 == "1") return (1);
   return (0);
}

string StringLower(string as0) {
   int li36;
   string lsret8 = "";
   string ls16 = "abcdefghijklmnopqrstuvwxyz";
   string ls24 = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
   for (int li32 = 0; li32 < StringLen(as0); li32++) {
      li36 = StringFind(ls24, StringSubstr(as0, li32, 1), 0);
      if (li36 >= 0) lsret8 = lsret8 + StringSubstr(ls16, li36, 1);
      else lsret8 = lsret8 + StringSubstr(as0, li32, 1);
   }
   return (lsret8);
}

